import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Samus Aran from the Metroid series.
 * 
 * @author Linish 
 * @version 1.2.2
 */
public class Samus extends Actor
{
private GreenfootImage[] imagesLeft;
private GreenfootImage[] imagesRight;
private int currentImage = 0;
private int vSpeed = 0;
private int accel = 1;
private int jumpStrength = 8;
public static int direction = 0;
private int food = 2;
private int gunHeat = 0;

public Samus()
{
imagesLeft = new GreenfootImage[8];
for(int f=0; f < 8; f++) {
imagesLeft[f] = new GreenfootImage("runleft" + f + ".png");
}
imagesRight = new GreenfootImage[8];
for(int i=0; i < 8; i++) {
imagesRight[i] = new GreenfootImage("right" + i + ".png");
}
}
/**
 * Checks which keys are being pressed
 * and checks if Samus if falling. Also
 * tells the counters to add if they are
 * greater than or equal to 0.
 */
public void act() 
{
if(gunHeat > 0) {
gunHeat--;
}
setImage("right0.png");
checkKeys();
checkFall();
if(lookAhead()) {
setLocation( getX() -5, getY()); 
}
if(vSpeed==15)
{
vSpeed=15;
}
if(!onGround()) {
if(direction==0) {
setImage("right0.png");
}
if(direction==1) {
setImage("runleft0.png");
}
}
}  
/**
 * Checks which keys are being pressed.
 */                               
public void checkKeys()
{
if(Greenfoot.isKeyDown("right"))
{
animateRight();
setLocation(getX() + 3, getY());
direction = 0;
}
if(!Greenfoot.isKeyDown("right"))
{
setImage("right0.png");
}                            
if(Greenfoot.isKeyDown("left"))
{
animateLeft();
setLocation(getX() - 3, getY());
direction = 1;
food = 1;
}
if(!Greenfoot.isKeyDown("left")&&direction==1)
{
setImage("runleft0.png");
}
if(Greenfoot.isKeyDown("up"))
{
if(onGround())  {
jump();
}
}
if(Greenfoot.isKeyDown("space")&&gunHeat==0)
{
getWorld().addObject(new Bullet(), getX(), getY());
gunHeat = 6;
}
}
/**
 * Makes Samus fall if she is not touching
 * Ground.
 */                 
public void fall()
{
setLocation(getX(), getY() + vSpeed);
vSpeed = vSpeed + accel;
}
/**
 * Checks if Samus if falling.
 */
public void checkFall()
{
if(onGround())                  
{
vSpeed = 0;
}
else                    
{
fall();
}
}
/**
 * Identifies what being on Ground means.
 */
public boolean onGround()
{
Actor under = getOneObjectAtOffset( 0, getImage().getHeight()/2, Ground.class);
return under != null;
}
/**
 * Makes Samus jump.
 */
public void jump()
{
vSpeed = -jumpStrength;
fall(); // gravity counteracts jumpStrength
}
/**
 * Determines whether Samus is approaching a wall on either side.
 * The side that's checked is determined by which arrow key is being
 * held down.
 *
 * @return true if Samus is approaching a wall, false otherwise.
 */     
public boolean approachWall()
{
int widthOffset = (Greenfoot.isKeyDown("left") ? -1 : 1)*getImage().getWidth()/2;
for(int i=-15 ; i<15 ; i++) 
{
boolean result = getOneObjectAtOffset(widthOffset, i, Ground.class)!=null;
if(result) return true;
}
return false;
}
/**
 * Keeps Samus from falling underground.
 */
public boolean lookAhead()
{
Actor a = getOneObjectAtOffset(0-480,442, Ground.class);
if(a!=null) {
return true;
}
else {
return false;
}
}
/**
 * Animates Samus on the right.
 */
public void animateRight()
{
currentImage = (currentImage + 1) % imagesRight.length;
setImage(imagesRight[currentImage]);
}
/**
 * Animates Samus on the left.
 */
public void animateLeft()
{
currentImage = (currentImage + 1) % imagesLeft.length;
setImage(imagesLeft[currentImage]);
}
//END                                        

                    }
